sdl2-2.5.2.0: Both high- and low-level bindings to the SDL library (version 2.0.6+).

Safe Haskell | None
Language | Haskell2010

SDL.Event

Contents

- Polling events
- Registering user events
- Watching events
- Event data
  - Window events
  - Keyboard events
  - Mouse events
  - Joystick events
  - Controller events
  - Audio events
  - User events
  - Touch events
  - Gesture events
  - Drag and drop events
  - Unknown events
- Auxiliary event data

Description

SDL.Event exports an interface for working with the SDL event model. Event handling allows your application to receive input from the user. Internally, SDL stores all the events waiting to be handled in an event queue. Using functions like `pollEvent` and `waitEvent` you can observe and handle waiting input events.

The event queue itself is composed of a series of `Event` values, one for each waiting event. `Event` values are read from the queue with the `pollEvent` function and it is then up to the application to process the information stored with them.

Synopsis

- pollEvent :: MonadIO m => m (Maybe Event)
- pollEvents :: (Functor m, MonadIO m) => m [Event]
- mapEvents :: MonadIO m => (Event -> m ()) -> m ()
- pumpEvents :: MonadIO m => m ()
- waitEvent :: MonadIO m => m Event
- waitEventTimeout :: MonadIO m => CInt -> m (Maybe Event)
- data RegisteredEventType a = RegisteredEventType {
  - pushRegisteredEvent :: a -> IO EventPushResult
  - getRegisteredEvent :: Event -> IO (Maybe a)
  }
- data RegisteredEventData = RegisteredEventData {
  - registeredEventWindow :: !(Maybe Window)
  - registeredEventCode :: !Int32
  - registeredEventData1 :: !(Ptr ())
  - registeredEventData2 :: !(Ptr ())
  }
- data EventPushResult
  - = EventPushSuccess
  - | EventPushFiltered
  - | EventPushFailure Text
- emptyRegisteredEvent :: RegisteredEventData
- registerEvent :: MonadIO m => (RegisteredEventData -> Timestamp -> IO (Maybe a)) -> (a -> IO RegisteredEventData) -> m (Maybe (RegisteredEventType a))
- type EventWatchCallback = Event -> IO ()
- data EventWatch
- addEventWatch :: MonadIO m => EventWatchCallback -> m EventWatch
- delEventWatch :: MonadIO m => EventWatch -> m ()
- data Event = Event {
  - eventTimestamp :: Timestamp
  - eventPayload :: EventPayload
  }
- type Timestamp = Word32
- data EventPayload
  - = WindowShownEvent !WindowShownEventData
  - | WindowHiddenEvent !WindowHiddenEventData
  - | WindowExposedEvent !WindowExposedEventData
  - | WindowMovedEvent !WindowMovedEventData
  - | WindowResizedEvent !WindowResizedEventData
  - | WindowSizeChangedEvent !WindowSizeChangedEventData
  - | WindowMinimizedEvent !WindowMinimizedEventData
  - | WindowMaximizedEvent !WindowMaximizedEventData
  - | WindowRestoredEvent !WindowRestoredEventData
  - | WindowGainedMouseFocusEvent !WindowGainedMouseFocusEventData
  - | WindowLostMouseFocusEvent !WindowLostMouseFocusEventData
  - | WindowGainedKeyboardFocusEvent !WindowGainedKeyboardFocusEventData
  - | WindowLostKeyboardFocusEvent !WindowLostKeyboardFocusEventData
  - | WindowClosedEvent !WindowClosedEventData
  - | KeyboardEvent !KeyboardEventData
  - | TextEditingEvent !TextEditingEventData
  - | TextInputEvent !TextInputEventData
  - | KeymapChangedEvent
  - | MouseMotionEvent !MouseMotionEventData
  - | MouseButtonEvent !MouseButtonEventData
  - | MouseWheelEvent !MouseWheelEventData
  - | JoyAxisEvent !JoyAxisEventData
  - | JoyBallEvent !JoyBallEventData
  - | JoyHatEvent !JoyHatEventData
  - | JoyButtonEvent !JoyButtonEventData
  - | JoyDeviceEvent !JoyDeviceEventData
  - | ControllerAxisEvent !ControllerAxisEventData
  - | ControllerButtonEvent !ControllerButtonEventData
  - | ControllerDeviceEvent !ControllerDeviceEventData
  - | AudioDeviceEvent !AudioDeviceEventData
  - | QuitEvent
  - | UserEvent !UserEventData
  - | SysWMEvent !SysWMEventData
  - | TouchFingerEvent !TouchFingerEventData
  - | TouchFingerMotionEvent !TouchFingerMotionEventData
  - | MultiGestureEvent !MultiGestureEventData
  - | DollarGestureEvent !DollarGestureEventData
  - | DropEvent !DropEventData
  - | ClipboardUpdateEvent
  - | UnknownEvent !UnknownEventData
- newtype WindowShownEventData = WindowShownEventData {
  - windowShownEventWindow :: Window
  }
- newtype WindowHiddenEventData = WindowHiddenEventData {
  - windowHiddenEventWindow :: Window
  }
- newtype WindowExposedEventData = WindowExposedEventData {
  - windowExposedEventWindow :: Window
  }
- data WindowMovedEventData = WindowMovedEventData {
  - windowMovedEventWindow :: !Window
  - windowMovedEventPosition :: !(Point V2 Int32)
  }
- data WindowResizedEventData = WindowResizedEventData {
  - windowResizedEventWindow :: !Window
  - windowResizedEventSize :: !(V2 Int32)
  }
- data WindowSizeChangedEventData = WindowSizeChangedEventData {
  - windowSizeChangedEventWindow :: !Window
  - windowSizeChangedEventSize :: !(V2 Int32)
  }
- newtype WindowMinimizedEventData = WindowMinimizedEventData {
  - windowMinimizedEventWindow :: Window
  }
- newtype WindowMaximizedEventData = WindowMaximizedEventData {
  - windowMaximizedEventWindow :: Window
  }
- newtype WindowRestoredEventData = WindowRestoredEventData {
  - windowRestoredEventWindow :: Window
  }
- newtype WindowGainedMouseFocusEventData = WindowGainedMouseFocusEventData {
  - windowGainedMouseFocusEventWindow :: Window
  }
- newtype WindowLostMouseFocusEventData = WindowLostMouseFocusEventData {
  - windowLostMouseFocusEventWindow :: Window
  }
- newtype WindowGainedKeyboardFocusEventData = WindowGainedKeyboardFocusEventData {
  - windowGainedKeyboardFocusEventWindow :: Window
  }
- newtype WindowLostKeyboardFocusEventData = WindowLostKeyboardFocusEventData {
  - windowLostKeyboardFocusEventWindow :: Window
  }
- newtype WindowClosedEventData = WindowClosedEventData {
  - windowClosedEventWindow :: Window
  }
- newtype SysWMEventData = SysWMEventData {
  - sysWMEventMsg :: SysWMmsg
  }
- data KeyboardEventData = KeyboardEventData {
  - keyboardEventWindow :: !(Maybe Window)
  - keyboardEventKeyMotion :: !InputMotion
  - keyboardEventRepeat :: !Bool
  - keyboardEventKeysym :: !Keysym
  }
- data TextEditingEventData = TextEditingEventData {
  - textEditingEventWindow :: !(Maybe Window)
  - textEditingEventText :: !Text
  - textEditingEventStart :: !Int32
  - textEditingEventLength :: !Int32
  }
- data TextInputEventData = TextInputEventData {
  - textInputEventWindow :: !(Maybe Window)
  - textInputEventText :: !Text
  }
- data MouseMotionEventData = MouseMotionEventData {
  - mouseMotionEventWindow :: !(Maybe Window)
  - mouseMotionEventWhich :: !MouseDevice
  - mouseMotionEventState :: ![MouseButton]
  - mouseMotionEventPos :: !(Point V2 Int32)
  - mouseMotionEventRelMotion :: !(V2 Int32)
  }
- data MouseButtonEventData = MouseButtonEventData {
  - mouseButtonEventWindow :: !(Maybe Window)
  - mouseButtonEventMotion :: !InputMotion
  - mouseButtonEventWhich :: !MouseDevice
  - mouseButtonEventButton :: !MouseButton
  - mouseButtonEventClicks :: !Word8
  - mouseButtonEventPos :: !(Point V2 Int32)
  }
- data MouseWheelEventData = MouseWheelEventData {
  - mouseWheelEventWindow :: !(Maybe Window)
  - mouseWheelEventWhich :: !MouseDevice
  - mouseWheelEventPos :: !(V2 Int32)
  - mouseWheelEventDirection :: !MouseScrollDirection
  }
- data JoyAxisEventData = JoyAxisEventData {
  - joyAxisEventWhich :: !JoystickID
  - joyAxisEventAxis :: !Word8
  - joyAxisEventValue :: !Int16
  }
- data JoyBallEventData = JoyBallEventData {
  - joyBallEventWhich :: !JoystickID
  - joyBallEventBall :: !Word8
  - joyBallEventRelMotion :: !(V2 Int16)
  }
- data JoyHatEventData = JoyHatEventData {
  - joyHatEventWhich :: !JoystickID
  - joyHatEventHat :: !Word8
  - joyHatEventValue :: !JoyHatPosition
  }
- data JoyButtonEventData = JoyButtonEventData {
  - joyButtonEventWhich :: !JoystickID
  - joyButtonEventButton :: !Word8
  - joyButtonEventState :: !JoyButtonState
  }
- data JoyDeviceEventData = JoyDeviceEventData {
  - joyDeviceEventConnection :: !JoyDeviceConnection
  - joyDeviceEventWhich :: !Int32
  }
- data ControllerAxisEventData = ControllerAxisEventData {
  - controllerAxisEventWhich :: !JoystickID
  - controllerAxisEventAxis :: !Word8
  - controllerAxisEventValue :: !Int16
  }
- data ControllerButtonEventData = ControllerButtonEventData {
  - controllerButtonEventWhich :: !JoystickID
  - controllerButtonEventButton :: !ControllerButton
  - controllerButtonEventState :: !ControllerButtonState
  }
- data ControllerDeviceEventData = ControllerDeviceEventData {
  - controllerDeviceEventConnection :: !ControllerDeviceConnection
  - controllerDeviceEventWhich :: !Int32
  }
- data AudioDeviceEventData = AudioDeviceEventData {
  - audioDeviceEventIsAddition :: !Bool
  - audioDeviceEventWhich :: !Word32
  - audioDeviceEventIsCapture :: !Bool
  }
- data UserEventData = UserEventData {
  - userEventType :: !Word32
  - userEventWindow :: !(Maybe Window)
  - userEventCode :: !Int32
  - userEventData1 :: !(Ptr ())
  - userEventData2 :: !(Ptr ())
  }
- data TouchFingerEventData = TouchFingerEventData {
  - touchFingerEventTouchID :: !TouchID
  - touchFingerEventFingerID :: !FingerID
  - touchFingerEventMotion :: !InputMotion
  - touchFingerEventPos :: !(Point V2 CFloat)
  - touchFingerEventPressure :: !CFloat
  }
- data TouchFingerMotionEventData = TouchFingerMotionEventData {
  - touchFingerMotionEventTouchID :: !TouchID
  - touchFingerMotionEventFingerID :: !FingerID
  - touchFingerMotionEventPos :: !(Point V2 CFloat)
  - touchFingerMotionEventRelMotion :: !(V2 CFloat)
  - touchFingerMotionEventPressure :: !CFloat
  }
- data MultiGestureEventData = MultiGestureEventData {
  - multiGestureEventTouchID :: !TouchID
  - multiGestureEventDTheta :: !CFloat
  - multiGestureEventDDist :: !CFloat
  - multiGestureEventPos :: !(Point V2 CFloat)
  - multiGestureEventNumFingers :: !Word16
  }
- data DollarGestureEventData = DollarGestureEventData {
  - dollarGestureEventTouchID :: !TouchID
  - dollarGestureEventGestureID :: !GestureID
  - dollarGestureEventNumFingers :: !Word32
  - dollarGestureEventError :: !CFloat
  - dollarGestureEventPos :: !(Point V2 CFloat)
  }
- newtype DropEventData = DropEventData {
  - dropEventFile :: CString
  }
- newtype UnknownEventData = UnknownEventData {
  - unknownEventType :: Word32
  }
- data InputMotion
  - = Released
  - | Pressed
- data MouseButton
  - = ButtonLeft
  - | ButtonMiddle
  - | ButtonRight
  - | ButtonX1
  - | ButtonX2
  - | ButtonExtra !Int

# Polling events

pollEvent :: MonadIO m => m (Maybe Event) Source #

Poll for currently pending events. You can only call this function in the thread that set the video mode.

pollEvents :: (Functor m, MonadIO m) => m [Event] Source #

Clear the event queue by polling for all pending events.

mapEvents :: MonadIO m => (Event -> m ()) -> m () Source #

Run a monadic computation, accumulating over all known `Event`s.

This can be useful when used with a state monad, allowing you to fold all events together.

pumpEvents :: MonadIO m => m () Source #

Pump the event loop, gathering events from the input devices.

This function updates the event queue and internal input device state.

This should only be run in the thread that initialized the video subsystem, and for extra safety, you should consider only doing those things on the main thread in any case.

`pumpEvents` gathers all the pending input information from devices and places it in the event queue. Without calls to `pumpEvents` no events would ever be placed on the queue. Often the need for calls to `pumpEvents` is hidden from the user since `pollEvent` and `waitEvent` implicitly call `pumpEvents`. However, if you are not polling or waiting for events (e.g. you are filtering them), then you must call `pumpEvents` to force an event queue update.

See `SDL_PumpEvents` for C documentation.

waitEvent :: MonadIO m => m Event Source #

Wait indefinitely for the next available event.

waitEventTimeout Source #

Arguments

:: MonadIO m |
=> CInt | The maximum amount of time to wait, in milliseconds.
-> m (Maybe Event) |

Wait until the specified timeout for the next available amount.

# Registering user events

data RegisteredEventType a Source #

A user defined event structure that has been registered with SDL.

Use `registerEvent`, below, to obtain an instance.

Constructors

RegisteredEventType |

Fields

- pushRegisteredEvent :: a -> IO EventPushResult
- getRegisteredEvent :: Event -> IO (Maybe a)

data RegisteredEventData Source #

A record used to convert between SDL Events and user-defined data structures.

Used for `registerEvent`, below.

Constructors

RegisteredEventData |

Fields

- registeredEventWindow :: !(Maybe Window)

  The associated `Window`.

- registeredEventCode :: !Int32

  User defined event code.

- registeredEventData1 :: !(Ptr ())

  User defined data pointer.

- registeredEventData2 :: !(Ptr ())

  User defined data pointer.

#### Instances

Instances details

Eq RegisteredEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: RegisteredEventData -> RegisteredEventData -> Bool (/=) :: RegisteredEventData -> RegisteredEventData -> Bool
Ord RegisteredEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: RegisteredEventData -> RegisteredEventData -> Ordering

(<) :: RegisteredEventData -> RegisteredEventData -> Bool

(<=) :: RegisteredEventData -> RegisteredEventData -> Bool

(>) :: RegisteredEventData -> RegisteredEventData -> Bool

(>=) :: RegisteredEventData -> RegisteredEventData -> Bool

max :: RegisteredEventData -> RegisteredEventData -> RegisteredEventData

min :: RegisteredEventData -> RegisteredEventData -> RegisteredEventData

Show RegisteredEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> RegisteredEventData -> ShowS show :: RegisteredEventData -> String showList :: [RegisteredEventData] -> ShowS
Generic RegisteredEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep RegisteredEventData :: Type -> Type Methods from :: RegisteredEventData -> Rep RegisteredEventData x to :: Rep RegisteredEventData x -> RegisteredEventData
type Rep RegisteredEventData Source # |

Instance details

Defined in SDL.Event

type Rep RegisteredEventData = D1 ('MetaData "RegisteredEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "RegisteredEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "registeredEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "registeredEventCode") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int32)) :*: (S1 ('MetaSel ('Just "registeredEventData1") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Ptr ())) :*: S1 ('MetaSel ('Just "registeredEventData2") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Ptr ())))))

data EventPushResult Source #

Possible results of an attempted push of an event to the queue.

Constructors

EventPushSuccess |
EventPushFiltered |
EventPushFailure Text |

#### Instances

Instances details

Eq EventPushResult Source # |
Instance details Defined in SDL.Event Methods (==) :: EventPushResult -> EventPushResult -> Bool (/=) :: EventPushResult -> EventPushResult -> Bool
Data EventPushResult Source # |

Instance details

Defined in SDL.Event

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> EventPushResult -> c EventPushResult

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c EventPushResult

toConstr :: EventPushResult -> Constr

dataTypeOf :: EventPushResult -> DataType

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c EventPushResult)

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c EventPushResult)

gmapT :: (forall b. Data b => b -> b) -> EventPushResult -> EventPushResult

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> EventPushResult -> r

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> EventPushResult -> r

gmapQ :: (forall d. Data d => d -> u) -> EventPushResult -> [u]

gmapQi :: Int -> (forall d. Data d => d -> u) -> EventPushResult -> u

gmapM :: Monad m => (forall d. Data d => d -> m d) -> EventPushResult -> m EventPushResult

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> EventPushResult -> m EventPushResult

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> EventPushResult -> m EventPushResult

Ord EventPushResult Source # |

Instance details

Defined in SDL.Event

Methods

compare :: EventPushResult -> EventPushResult -> Ordering

(<) :: EventPushResult -> EventPushResult -> Bool

(<=) :: EventPushResult -> EventPushResult -> Bool

(>) :: EventPushResult -> EventPushResult -> Bool

(>=) :: EventPushResult -> EventPushResult -> Bool

max :: EventPushResult -> EventPushResult -> EventPushResult

min :: EventPushResult -> EventPushResult -> EventPushResult

Read EventPushResult Source # |
Instance details Defined in SDL.Event Methods readsPrec :: Int -> ReadS EventPushResult readList :: ReadS [EventPushResult] readPrec :: ReadPrec EventPushResult readListPrec :: ReadPrec [EventPushResult]
Show EventPushResult Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> EventPushResult -> ShowS show :: EventPushResult -> String showList :: [EventPushResult] -> ShowS
Generic EventPushResult Source # |
Instance details Defined in SDL.Event Associated Types type Rep EventPushResult :: Type -> Type Methods from :: EventPushResult -> Rep EventPushResult x to :: Rep EventPushResult x -> EventPushResult
type Rep EventPushResult Source # |

Instance details

Defined in SDL.Event

type Rep EventPushResult = D1 ('MetaData "EventPushResult" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "EventPushSuccess" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "EventPushFiltered" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "EventPushFailure" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Text))))

emptyRegisteredEvent :: RegisteredEventData Source #

A registered event with no associated data.

This is a resonable baseline to modify for converting to `RegisteredEventData`.

registerEvent :: MonadIO m => (RegisteredEventData -> Timestamp -> IO (Maybe a)) -> (a -> IO RegisteredEventData) -> m (Maybe (RegisteredEventType a)) Source #

Register a new event type with SDL.

Provide functions that convert between `UserEventData` and your structure. You can then use `pushRegisteredEvent` to add a custom event of the registered type to the queue, and `getRegisteredEvent` to test for such events in the main loop.

# Watching events

type EventWatchCallback = Event -> IO () Source #

An `EventWatchCallback` can process and respond to an event when it is added to the event queue.

data EventWatch Source #

addEventWatch :: MonadIO m => EventWatchCallback -> m EventWatch Source #

Trigger an `EventWatchCallback` when an event is added to the SDL event queue.

See `https://wiki.libsdl.org/SDL_AddEventWatch` for C documentation.

delEventWatch :: MonadIO m => EventWatch -> m () Source #

Remove an `EventWatch`.

See `https://wiki.libsdl.org/SDL_DelEventWatch` for C documentation.

# Event data

data Event Source #

A single SDL event. This event occured at `eventTimestamp` and carries data under `eventPayload`.

Constructors

Event |

Fields

- eventTimestamp :: Timestamp

  The time the event occured.

- eventPayload :: EventPayload

  Data pertaining to this event.

#### Instances

Instances details

Eq Event Source # |
Instance details Defined in SDL.Event Methods (==) :: Event -> Event -> Bool (/=) :: Event -> Event -> Bool
Ord Event Source # |
Instance details Defined in SDL.Event Methods compare :: Event -> Event -> Ordering (<) :: Event -> Event -> Bool (<=) :: Event -> Event -> Bool (>) :: Event -> Event -> Bool (>=) :: Event -> Event -> Bool max :: Event -> Event -> Event min :: Event -> Event -> Event
Show Event Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> Event -> ShowS show :: Event -> String showList :: [Event] -> ShowS
Generic Event Source # |
Instance details Defined in SDL.Event Associated Types type Rep Event :: Type -> Type Methods from :: Event -> Rep Event x to :: Rep Event x -> Event
type Rep Event Source # |

Instance details

Defined in SDL.Event

type Rep Event = D1 ('MetaData "Event" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "Event" 'PrefixI 'True) (S1 ('MetaSel ('Just "eventTimestamp") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Timestamp) :*: S1 ('MetaSel ('Just "eventPayload") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 EventPayload)))

type Timestamp = Word32 Source #

data EventPayload Source #

An enumeration of all possible SDL event types. This data type pairs up event types with their payload, where possible.

Constructors

WindowShownEvent !WindowShownEventData |
WindowHiddenEvent !WindowHiddenEventData |
WindowExposedEvent !WindowExposedEventData |
WindowMovedEvent !WindowMovedEventData |
WindowResizedEvent !WindowResizedEventData |
WindowSizeChangedEvent !WindowSizeChangedEventData |
WindowMinimizedEvent !WindowMinimizedEventData |
WindowMaximizedEvent !WindowMaximizedEventData |
WindowRestoredEvent !WindowRestoredEventData |
WindowGainedMouseFocusEvent !WindowGainedMouseFocusEventData |
WindowLostMouseFocusEvent !WindowLostMouseFocusEventData |
WindowGainedKeyboardFocusEvent !WindowGainedKeyboardFocusEventData |
WindowLostKeyboardFocusEvent !WindowLostKeyboardFocusEventData |
WindowClosedEvent !WindowClosedEventData |
KeyboardEvent !KeyboardEventData |
TextEditingEvent !TextEditingEventData |
TextInputEvent !TextInputEventData |
KeymapChangedEvent |
MouseMotionEvent !MouseMotionEventData |
MouseButtonEvent !MouseButtonEventData |
MouseWheelEvent !MouseWheelEventData |
JoyAxisEvent !JoyAxisEventData |
JoyBallEvent !JoyBallEventData |
JoyHatEvent !JoyHatEventData |
JoyButtonEvent !JoyButtonEventData |
JoyDeviceEvent !JoyDeviceEventData |
ControllerAxisEvent !ControllerAxisEventData |
ControllerButtonEvent !ControllerButtonEventData |
ControllerDeviceEvent !ControllerDeviceEventData |
AudioDeviceEvent !AudioDeviceEventData |
QuitEvent |
UserEvent !UserEventData |
SysWMEvent !SysWMEventData |
TouchFingerEvent !TouchFingerEventData |
TouchFingerMotionEvent !TouchFingerMotionEventData |
MultiGestureEvent !MultiGestureEventData |
DollarGestureEvent !DollarGestureEventData |
DropEvent !DropEventData |
ClipboardUpdateEvent |
UnknownEvent !UnknownEventData |

#### Instances

Instances details

Eq EventPayload Source # |
Instance details Defined in SDL.Event Methods (==) :: EventPayload -> EventPayload -> Bool (/=) :: EventPayload -> EventPayload -> Bool
Ord EventPayload Source # |
Instance details Defined in SDL.Event Methods compare :: EventPayload -> EventPayload -> Ordering (<) :: EventPayload -> EventPayload -> Bool (<=) :: EventPayload -> EventPayload -> Bool (>) :: EventPayload -> EventPayload -> Bool (>=) :: EventPayload -> EventPayload -> Bool max :: EventPayload -> EventPayload -> EventPayload min :: EventPayload -> EventPayload -> EventPayload
Show EventPayload Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> EventPayload -> ShowS show :: EventPayload -> String showList :: [EventPayload] -> ShowS
Generic EventPayload Source # |
Instance details Defined in SDL.Event Associated Types type Rep EventPayload :: Type -> Type Methods from :: EventPayload -> Rep EventPayload x to :: Rep EventPayload x -> EventPayload
type Rep EventPayload Source # |

Instance details

Defined in SDL.Event

type Rep EventPayload = D1 ('MetaData "EventPayload" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (((((C1 ('MetaCons "WindowShownEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowShownEventData)) :+: C1 ('MetaCons "WindowHiddenEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowHiddenEventData))) :+: (C1 ('MetaCons "WindowExposedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowExposedEventData)) :+: (C1 ('MetaCons "WindowMovedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowMovedEventData)) :+: C1 ('MetaCons "WindowResizedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowResizedEventData))))) :+: ((C1 ('MetaCons "WindowSizeChangedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowSizeChangedEventData)) :+: C1 ('MetaCons "WindowMinimizedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowMinimizedEventData))) :+: (C1 ('MetaCons "WindowMaximizedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowMaximizedEventData)) :+: (C1 ('MetaCons "WindowRestoredEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowRestoredEventData)) :+: C1 ('MetaCons "WindowGainedMouseFocusEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowGainedMouseFocusEventData)))))) :+: (((C1 ('MetaCons "WindowLostMouseFocusEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowLostMouseFocusEventData)) :+: C1 ('MetaCons "WindowGainedKeyboardFocusEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowGainedKeyboardFocusEventData))) :+: (C1 ('MetaCons "WindowLostKeyboardFocusEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowLostKeyboardFocusEventData)) :+: (C1 ('MetaCons "WindowClosedEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 WindowClosedEventData)) :+: C1 ('MetaCons "KeyboardEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 KeyboardEventData))))) :+: ((C1 ('MetaCons "TextEditingEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TextEditingEventData)) :+: C1 ('MetaCons "TextInputEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TextInputEventData))) :+: (C1 ('MetaCons "KeymapChangedEvent" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "MouseMotionEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseMotionEventData)) :+: C1 ('MetaCons "MouseButtonEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseButtonEventData))))))) :+: ((((C1 ('MetaCons "MouseWheelEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseWheelEventData)) :+: C1 ('MetaCons "JoyAxisEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyAxisEventData))) :+: (C1 ('MetaCons "JoyBallEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyBallEventData)) :+: (C1 ('MetaCons "JoyHatEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyHatEventData)) :+: C1 ('MetaCons "JoyButtonEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyButtonEventData))))) :+: ((C1 ('MetaCons "JoyDeviceEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyDeviceEventData)) :+: C1 ('MetaCons "ControllerAxisEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerAxisEventData))) :+: (C1 ('MetaCons "ControllerButtonEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerButtonEventData)) :+: (C1 ('MetaCons "ControllerDeviceEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerDeviceEventData)) :+: C1 ('MetaCons "AudioDeviceEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 AudioDeviceEventData)))))) :+: (((C1 ('MetaCons "QuitEvent" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "UserEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 UserEventData))) :+: (C1 ('MetaCons "SysWMEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 SysWMEventData)) :+: (C1 ('MetaCons "TouchFingerEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchFingerEventData)) :+: C1 ('MetaCons "TouchFingerMotionEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchFingerMotionEventData))))) :+: ((C1 ('MetaCons "MultiGestureEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MultiGestureEventData)) :+: C1 ('MetaCons "DollarGestureEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 DollarGestureEventData))) :+: (C1 ('MetaCons "DropEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 DropEventData)) :+: (C1 ('MetaCons "ClipboardUpdateEvent" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "UnknownEvent" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 UnknownEventData))))))))

## Window events

newtype WindowShownEventData Source #

A window has been shown.

Constructors

WindowShownEventData |

Fields

- windowShownEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowShownEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowShownEventData -> WindowShownEventData -> Bool (/=) :: WindowShownEventData -> WindowShownEventData -> Bool
Ord WindowShownEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowShownEventData -> WindowShownEventData -> Ordering

(<) :: WindowShownEventData -> WindowShownEventData -> Bool

(<=) :: WindowShownEventData -> WindowShownEventData -> Bool

(>) :: WindowShownEventData -> WindowShownEventData -> Bool

(>=) :: WindowShownEventData -> WindowShownEventData -> Bool

max :: WindowShownEventData -> WindowShownEventData -> WindowShownEventData

min :: WindowShownEventData -> WindowShownEventData -> WindowShownEventData

Show WindowShownEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowShownEventData -> ShowS show :: WindowShownEventData -> String showList :: [WindowShownEventData] -> ShowS
Generic WindowShownEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowShownEventData :: Type -> Type Methods from :: WindowShownEventData -> Rep WindowShownEventData x to :: Rep WindowShownEventData x -> WindowShownEventData
type Rep WindowShownEventData Source # |
Instance details Defined in SDL.Event type Rep WindowShownEventData = D1 ('MetaData "WindowShownEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowShownEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowShownEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowHiddenEventData Source #

A window has been hidden.

Constructors

WindowHiddenEventData |

Fields

- windowHiddenEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowHiddenEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool (/=) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool
Ord WindowHiddenEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowHiddenEventData -> WindowHiddenEventData -> Ordering

(<) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool

(<=) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool

(>) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool

(>=) :: WindowHiddenEventData -> WindowHiddenEventData -> Bool

max :: WindowHiddenEventData -> WindowHiddenEventData -> WindowHiddenEventData

min :: WindowHiddenEventData -> WindowHiddenEventData -> WindowHiddenEventData

Show WindowHiddenEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowHiddenEventData -> ShowS show :: WindowHiddenEventData -> String showList :: [WindowHiddenEventData] -> ShowS
Generic WindowHiddenEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowHiddenEventData :: Type -> Type Methods from :: WindowHiddenEventData -> Rep WindowHiddenEventData x to :: Rep WindowHiddenEventData x -> WindowHiddenEventData
type Rep WindowHiddenEventData Source # |
Instance details Defined in SDL.Event type Rep WindowHiddenEventData = D1 ('MetaData "WindowHiddenEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowHiddenEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowHiddenEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowExposedEventData Source #

A part of a window has been exposed - where exposure means to become visible (for example, an overlapping window no longer overlaps with the window).

Constructors

WindowExposedEventData |

Fields

- windowExposedEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowExposedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowExposedEventData -> WindowExposedEventData -> Bool (/=) :: WindowExposedEventData -> WindowExposedEventData -> Bool
Ord WindowExposedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowExposedEventData -> WindowExposedEventData -> Ordering

(<) :: WindowExposedEventData -> WindowExposedEventData -> Bool

(<=) :: WindowExposedEventData -> WindowExposedEventData -> Bool

(>) :: WindowExposedEventData -> WindowExposedEventData -> Bool

(>=) :: WindowExposedEventData -> WindowExposedEventData -> Bool

max :: WindowExposedEventData -> WindowExposedEventData -> WindowExposedEventData

min :: WindowExposedEventData -> WindowExposedEventData -> WindowExposedEventData

Show WindowExposedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowExposedEventData -> ShowS show :: WindowExposedEventData -> String showList :: [WindowExposedEventData] -> ShowS
Generic WindowExposedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowExposedEventData :: Type -> Type Methods from :: WindowExposedEventData -> Rep WindowExposedEventData x to :: Rep WindowExposedEventData x -> WindowExposedEventData
type Rep WindowExposedEventData Source # |
Instance details Defined in SDL.Event type Rep WindowExposedEventData = D1 ('MetaData "WindowExposedEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowExposedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowExposedEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

data WindowMovedEventData Source #

A `Window` has been moved.

Constructors

WindowMovedEventData |

Fields

- windowMovedEventWindow :: !Window

  The associated `Window`.

- windowMovedEventPosition :: !(Point V2 Int32)

  The new position of the `Window`.

#### Instances

Instances details

Eq WindowMovedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowMovedEventData -> WindowMovedEventData -> Bool (/=) :: WindowMovedEventData -> WindowMovedEventData -> Bool
Ord WindowMovedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowMovedEventData -> WindowMovedEventData -> Ordering

(<) :: WindowMovedEventData -> WindowMovedEventData -> Bool

(<=) :: WindowMovedEventData -> WindowMovedEventData -> Bool

(>) :: WindowMovedEventData -> WindowMovedEventData -> Bool

(>=) :: WindowMovedEventData -> WindowMovedEventData -> Bool

max :: WindowMovedEventData -> WindowMovedEventData -> WindowMovedEventData

min :: WindowMovedEventData -> WindowMovedEventData -> WindowMovedEventData

Show WindowMovedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowMovedEventData -> ShowS show :: WindowMovedEventData -> String showList :: [WindowMovedEventData] -> ShowS
Generic WindowMovedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowMovedEventData :: Type -> Type Methods from :: WindowMovedEventData -> Rep WindowMovedEventData x to :: Rep WindowMovedEventData x -> WindowMovedEventData
type Rep WindowMovedEventData Source # |

Instance details

Defined in SDL.Event

type Rep WindowMovedEventData = D1 ('MetaData "WindowMovedEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "WindowMovedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowMovedEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Window) :*: S1 ('MetaSel ('Just "windowMovedEventPosition") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 Int32))))

data WindowResizedEventData Source #

Window has been resized. This is event is always preceded by `WindowSizeChangedEvent`.

Constructors

WindowResizedEventData |

Fields

- windowResizedEventWindow :: !Window

  The associated `Window`.

- windowResizedEventSize :: !(V2 Int32)

  The new size of the `Window`.

#### Instances

Instances details

Eq WindowResizedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowResizedEventData -> WindowResizedEventData -> Bool (/=) :: WindowResizedEventData -> WindowResizedEventData -> Bool
Ord WindowResizedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowResizedEventData -> WindowResizedEventData -> Ordering

(<) :: WindowResizedEventData -> WindowResizedEventData -> Bool

(<=) :: WindowResizedEventData -> WindowResizedEventData -> Bool

(>) :: WindowResizedEventData -> WindowResizedEventData -> Bool

(>=) :: WindowResizedEventData -> WindowResizedEventData -> Bool

max :: WindowResizedEventData -> WindowResizedEventData -> WindowResizedEventData

min :: WindowResizedEventData -> WindowResizedEventData -> WindowResizedEventData

Show WindowResizedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowResizedEventData -> ShowS show :: WindowResizedEventData -> String showList :: [WindowResizedEventData] -> ShowS
Generic WindowResizedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowResizedEventData :: Type -> Type Methods from :: WindowResizedEventData -> Rep WindowResizedEventData x to :: Rep WindowResizedEventData x -> WindowResizedEventData
type Rep WindowResizedEventData Source # |

Instance details

Defined in SDL.Event

type Rep WindowResizedEventData = D1 ('MetaData "WindowResizedEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "WindowResizedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowResizedEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Window) :*: S1 ('MetaSel ('Just "windowResizedEventSize") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 Int32))))

data WindowSizeChangedEventData Source #

The window size has changed, either as a result of an API call or through the system or user changing the window size; this event is followed by `WindowResizedEvent` if the size was changed by an external event, i.e. the user or the window manager.

Constructors

WindowSizeChangedEventData |

Fields

- windowSizeChangedEventWindow :: !Window

  The associated `Window`.

- windowSizeChangedEventSize :: !(V2 Int32)

  The new size of the `Window`.

#### Instances

Instances details

Eq WindowSizeChangedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool (/=) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool
Ord WindowSizeChangedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Ordering

(<) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool

(<=) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool

(>) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool

(>=) :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> Bool

max :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> WindowSizeChangedEventData

min :: WindowSizeChangedEventData -> WindowSizeChangedEventData -> WindowSizeChangedEventData

Show WindowSizeChangedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowSizeChangedEventData -> ShowS show :: WindowSizeChangedEventData -> String showList :: [WindowSizeChangedEventData] -> ShowS
Generic WindowSizeChangedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowSizeChangedEventData :: Type -> Type Methods from :: WindowSizeChangedEventData -> Rep WindowSizeChangedEventData x to :: Rep WindowSizeChangedEventData x -> WindowSizeChangedEventData
type Rep WindowSizeChangedEventData Source # |

Instance details

Defined in SDL.Event

type Rep WindowSizeChangedEventData = D1 ('MetaData "WindowSizeChangedEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "WindowSizeChangedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowSizeChangedEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Window) :*: S1 ('MetaSel ('Just "windowSizeChangedEventSize") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 Int32))))

newtype WindowMinimizedEventData Source #

The window has been minimized.

Constructors

WindowMinimizedEventData |

Fields

- windowMinimizedEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowMinimizedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool (/=) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool
Ord WindowMinimizedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowMinimizedEventData -> WindowMinimizedEventData -> Ordering

(<) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool

(<=) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool

(>) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool

(>=) :: WindowMinimizedEventData -> WindowMinimizedEventData -> Bool

max :: WindowMinimizedEventData -> WindowMinimizedEventData -> WindowMinimizedEventData

min :: WindowMinimizedEventData -> WindowMinimizedEventData -> WindowMinimizedEventData

Show WindowMinimizedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowMinimizedEventData -> ShowS show :: WindowMinimizedEventData -> String showList :: [WindowMinimizedEventData] -> ShowS
Generic WindowMinimizedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowMinimizedEventData :: Type -> Type Methods from :: WindowMinimizedEventData -> Rep WindowMinimizedEventData x to :: Rep WindowMinimizedEventData x -> WindowMinimizedEventData
type Rep WindowMinimizedEventData Source # |
Instance details Defined in SDL.Event type Rep WindowMinimizedEventData = D1 ('MetaData "WindowMinimizedEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowMinimizedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowMinimizedEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowMaximizedEventData Source #

The window has been maximized.

Constructors

WindowMaximizedEventData |

Fields

- windowMaximizedEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowMaximizedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool (/=) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool
Ord WindowMaximizedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowMaximizedEventData -> WindowMaximizedEventData -> Ordering

(<) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool

(<=) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool

(>) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool

(>=) :: WindowMaximizedEventData -> WindowMaximizedEventData -> Bool

max :: WindowMaximizedEventData -> WindowMaximizedEventData -> WindowMaximizedEventData

min :: WindowMaximizedEventData -> WindowMaximizedEventData -> WindowMaximizedEventData

Show WindowMaximizedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowMaximizedEventData -> ShowS show :: WindowMaximizedEventData -> String showList :: [WindowMaximizedEventData] -> ShowS
Generic WindowMaximizedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowMaximizedEventData :: Type -> Type Methods from :: WindowMaximizedEventData -> Rep WindowMaximizedEventData x to :: Rep WindowMaximizedEventData x -> WindowMaximizedEventData
type Rep WindowMaximizedEventData Source # |
Instance details Defined in SDL.Event type Rep WindowMaximizedEventData = D1 ('MetaData "WindowMaximizedEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowMaximizedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowMaximizedEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowRestoredEventData Source #

The window has been restored to normal size and position.

Constructors

WindowRestoredEventData |

Fields

- windowRestoredEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowRestoredEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool (/=) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool
Ord WindowRestoredEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowRestoredEventData -> WindowRestoredEventData -> Ordering

(<) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool

(<=) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool

(>) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool

(>=) :: WindowRestoredEventData -> WindowRestoredEventData -> Bool

max :: WindowRestoredEventData -> WindowRestoredEventData -> WindowRestoredEventData

min :: WindowRestoredEventData -> WindowRestoredEventData -> WindowRestoredEventData

Show WindowRestoredEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowRestoredEventData -> ShowS show :: WindowRestoredEventData -> String showList :: [WindowRestoredEventData] -> ShowS
Generic WindowRestoredEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowRestoredEventData :: Type -> Type Methods from :: WindowRestoredEventData -> Rep WindowRestoredEventData x to :: Rep WindowRestoredEventData x -> WindowRestoredEventData
type Rep WindowRestoredEventData Source # |
Instance details Defined in SDL.Event type Rep WindowRestoredEventData = D1 ('MetaData "WindowRestoredEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowRestoredEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowRestoredEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowGainedMouseFocusEventData Source #

The window has gained mouse focus.

Constructors

WindowGainedMouseFocusEventData |

Fields

- windowGainedMouseFocusEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowGainedMouseFocusEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool (/=) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool
Ord WindowGainedMouseFocusEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Ordering

(<) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool

(<=) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool

(>) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool

(>=) :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> Bool

max :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData

min :: WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData -> WindowGainedMouseFocusEventData

Show WindowGainedMouseFocusEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowGainedMouseFocusEventData -> ShowS show :: WindowGainedMouseFocusEventData -> String showList :: [WindowGainedMouseFocusEventData] -> ShowS
Generic WindowGainedMouseFocusEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowGainedMouseFocusEventData :: Type -> Type Methods from :: WindowGainedMouseFocusEventData -> Rep WindowGainedMouseFocusEventData x to :: Rep WindowGainedMouseFocusEventData x -> WindowGainedMouseFocusEventData
type Rep WindowGainedMouseFocusEventData Source # |
Instance details Defined in SDL.Event type Rep WindowGainedMouseFocusEventData = D1 ('MetaData "WindowGainedMouseFocusEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowGainedMouseFocusEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowGainedMouseFocusEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowLostMouseFocusEventData Source #

The window has lost mouse focus.

Constructors

WindowLostMouseFocusEventData |

Fields

- windowLostMouseFocusEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowLostMouseFocusEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool (/=) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool
Ord WindowLostMouseFocusEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Ordering

(<) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool

(<=) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool

(>) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool

(>=) :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> Bool

max :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData

min :: WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData -> WindowLostMouseFocusEventData

Show WindowLostMouseFocusEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowLostMouseFocusEventData -> ShowS show :: WindowLostMouseFocusEventData -> String showList :: [WindowLostMouseFocusEventData] -> ShowS
Generic WindowLostMouseFocusEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowLostMouseFocusEventData :: Type -> Type Methods from :: WindowLostMouseFocusEventData -> Rep WindowLostMouseFocusEventData x to :: Rep WindowLostMouseFocusEventData x -> WindowLostMouseFocusEventData
type Rep WindowLostMouseFocusEventData Source # |
Instance details Defined in SDL.Event type Rep WindowLostMouseFocusEventData = D1 ('MetaData "WindowLostMouseFocusEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowLostMouseFocusEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowLostMouseFocusEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowGainedKeyboardFocusEventData Source #

The window has gained keyboard focus.

Constructors

WindowGainedKeyboardFocusEventData |

Fields

- windowGainedKeyboardFocusEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowGainedKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool (/=) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool
Ord WindowGainedKeyboardFocusEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Ordering

(<) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool

(<=) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool

(>) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool

(>=) :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> Bool

max :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData

min :: WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData -> WindowGainedKeyboardFocusEventData

Show WindowGainedKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowGainedKeyboardFocusEventData -> ShowS show :: WindowGainedKeyboardFocusEventData -> String showList :: [WindowGainedKeyboardFocusEventData] -> ShowS
Generic WindowGainedKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowGainedKeyboardFocusEventData :: Type -> Type Methods from :: WindowGainedKeyboardFocusEventData -> Rep WindowGainedKeyboardFocusEventData x to :: Rep WindowGainedKeyboardFocusEventData x -> WindowGainedKeyboardFocusEventData
type Rep WindowGainedKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event type Rep WindowGainedKeyboardFocusEventData = D1 ('MetaData "WindowGainedKeyboardFocusEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowGainedKeyboardFocusEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowGainedKeyboardFocusEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowLostKeyboardFocusEventData Source #

The window has lost keyboard focus.

Constructors

WindowLostKeyboardFocusEventData |

Fields

- windowLostKeyboardFocusEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowLostKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool (/=) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool
Ord WindowLostKeyboardFocusEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Ordering

(<) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool

(<=) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool

(>) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool

(>=) :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> Bool

max :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData

min :: WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData -> WindowLostKeyboardFocusEventData

Show WindowLostKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowLostKeyboardFocusEventData -> ShowS show :: WindowLostKeyboardFocusEventData -> String showList :: [WindowLostKeyboardFocusEventData] -> ShowS
Generic WindowLostKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowLostKeyboardFocusEventData :: Type -> Type Methods from :: WindowLostKeyboardFocusEventData -> Rep WindowLostKeyboardFocusEventData x to :: Rep WindowLostKeyboardFocusEventData x -> WindowLostKeyboardFocusEventData
type Rep WindowLostKeyboardFocusEventData Source # |
Instance details Defined in SDL.Event type Rep WindowLostKeyboardFocusEventData = D1 ('MetaData "WindowLostKeyboardFocusEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowLostKeyboardFocusEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowLostKeyboardFocusEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype WindowClosedEventData Source #

The window manager requests that the window be closed.

Constructors

WindowClosedEventData |

Fields

- windowClosedEventWindow :: Window

  The associated `Window`.

#### Instances

Instances details

Eq WindowClosedEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: WindowClosedEventData -> WindowClosedEventData -> Bool (/=) :: WindowClosedEventData -> WindowClosedEventData -> Bool
Ord WindowClosedEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: WindowClosedEventData -> WindowClosedEventData -> Ordering

(<) :: WindowClosedEventData -> WindowClosedEventData -> Bool

(<=) :: WindowClosedEventData -> WindowClosedEventData -> Bool

(>) :: WindowClosedEventData -> WindowClosedEventData -> Bool

(>=) :: WindowClosedEventData -> WindowClosedEventData -> Bool

max :: WindowClosedEventData -> WindowClosedEventData -> WindowClosedEventData

min :: WindowClosedEventData -> WindowClosedEventData -> WindowClosedEventData

Show WindowClosedEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> WindowClosedEventData -> ShowS show :: WindowClosedEventData -> String showList :: [WindowClosedEventData] -> ShowS
Generic WindowClosedEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep WindowClosedEventData :: Type -> Type Methods from :: WindowClosedEventData -> Rep WindowClosedEventData x to :: Rep WindowClosedEventData x -> WindowClosedEventData
type Rep WindowClosedEventData Source # |
Instance details Defined in SDL.Event type Rep WindowClosedEventData = D1 ('MetaData "WindowClosedEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "WindowClosedEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "windowClosedEventWindow") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Window)))

newtype SysWMEventData Source #

A video driver dependent system event

Constructors

SysWMEventData |

Fields

- sysWMEventMsg :: SysWMmsg

#### Instances

Instances details

Eq SysWMEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: SysWMEventData -> SysWMEventData -> Bool (/=) :: SysWMEventData -> SysWMEventData -> Bool
Ord SysWMEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: SysWMEventData -> SysWMEventData -> Ordering

(<) :: SysWMEventData -> SysWMEventData -> Bool

(<=) :: SysWMEventData -> SysWMEventData -> Bool

(>) :: SysWMEventData -> SysWMEventData -> Bool

(>=) :: SysWMEventData -> SysWMEventData -> Bool

max :: SysWMEventData -> SysWMEventData -> SysWMEventData

min :: SysWMEventData -> SysWMEventData -> SysWMEventData

Show SysWMEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> SysWMEventData -> ShowS show :: SysWMEventData -> String showList :: [SysWMEventData] -> ShowS
Generic SysWMEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep SysWMEventData :: Type -> Type Methods from :: SysWMEventData -> Rep SysWMEventData x to :: Rep SysWMEventData x -> SysWMEventData
type Rep SysWMEventData Source # |
Instance details Defined in SDL.Event type Rep SysWMEventData = D1 ('MetaData "SysWMEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "SysWMEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "sysWMEventMsg") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 SysWMmsg)))

## Keyboard events

data KeyboardEventData Source #

A keyboard key has been pressed or released.

Constructors

KeyboardEventData |

Fields

- keyboardEventWindow :: !(Maybe Window)

  The `Window` with keyboard focus, if any.

- keyboardEventKeyMotion :: !InputMotion

  Whether the key was pressed or released.

- keyboardEventRepeat :: !Bool

  `True` if this is a repeating key press from the user holding the key down.

- keyboardEventKeysym :: !Keysym

  A description of the key that this event pertains to.

#### Instances

Instances details

Eq KeyboardEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: KeyboardEventData -> KeyboardEventData -> Bool (/=) :: KeyboardEventData -> KeyboardEventData -> Bool
Ord KeyboardEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: KeyboardEventData -> KeyboardEventData -> Ordering

(<) :: KeyboardEventData -> KeyboardEventData -> Bool

(<=) :: KeyboardEventData -> KeyboardEventData -> Bool

(>) :: KeyboardEventData -> KeyboardEventData -> Bool

(>=) :: KeyboardEventData -> KeyboardEventData -> Bool

max :: KeyboardEventData -> KeyboardEventData -> KeyboardEventData

min :: KeyboardEventData -> KeyboardEventData -> KeyboardEventData

Show KeyboardEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> KeyboardEventData -> ShowS show :: KeyboardEventData -> String showList :: [KeyboardEventData] -> ShowS
Generic KeyboardEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep KeyboardEventData :: Type -> Type Methods from :: KeyboardEventData -> Rep KeyboardEventData x to :: Rep KeyboardEventData x -> KeyboardEventData
type Rep KeyboardEventData Source # |

Instance details

Defined in SDL.Event

type Rep KeyboardEventData = D1 ('MetaData "KeyboardEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "KeyboardEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "keyboardEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "keyboardEventKeyMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 InputMotion)) :*: (S1 ('MetaSel ('Just "keyboardEventRepeat") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool) :*: S1 ('MetaSel ('Just "keyboardEventKeysym") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Keysym))))

data TextEditingEventData Source #

Keyboard text editing event information.

Constructors

TextEditingEventData |

Fields

- textEditingEventWindow :: !(Maybe Window)

  The `Window` with keyboard focus, if any.

- textEditingEventText :: !Text

  The editing text.

- textEditingEventStart :: !Int32

  The location to begin editing from.

- textEditingEventLength :: !Int32

  The number of characters to edit from the start point.

#### Instances

Instances details

Eq TextEditingEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: TextEditingEventData -> TextEditingEventData -> Bool (/=) :: TextEditingEventData -> TextEditingEventData -> Bool
Ord TextEditingEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: TextEditingEventData -> TextEditingEventData -> Ordering

(<) :: TextEditingEventData -> TextEditingEventData -> Bool

(<=) :: TextEditingEventData -> TextEditingEventData -> Bool

(>) :: TextEditingEventData -> TextEditingEventData -> Bool

(>=) :: TextEditingEventData -> TextEditingEventData -> Bool

max :: TextEditingEventData -> TextEditingEventData -> TextEditingEventData

min :: TextEditingEventData -> TextEditingEventData -> TextEditingEventData

Show TextEditingEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> TextEditingEventData -> ShowS show :: TextEditingEventData -> String showList :: [TextEditingEventData] -> ShowS
Generic TextEditingEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep TextEditingEventData :: Type -> Type Methods from :: TextEditingEventData -> Rep TextEditingEventData x to :: Rep TextEditingEventData x -> TextEditingEventData
type Rep TextEditingEventData Source # |

Instance details

Defined in SDL.Event

type Rep TextEditingEventData = D1 ('MetaData "TextEditingEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "TextEditingEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "textEditingEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "textEditingEventText") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Text)) :*: (S1 ('MetaSel ('Just "textEditingEventStart") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int32) :*: S1 ('MetaSel ('Just "textEditingEventLength") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int32))))

data TextInputEventData Source #

Keyboard text input event information.

Constructors

TextInputEventData |

Fields

- textInputEventWindow :: !(Maybe Window)

  The `Window` with keyboard focus, if any.

- textInputEventText :: !Text

  The input text.

#### Instances

Instances details

Eq TextInputEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: TextInputEventData -> TextInputEventData -> Bool (/=) :: TextInputEventData -> TextInputEventData -> Bool
Ord TextInputEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: TextInputEventData -> TextInputEventData -> Ordering

(<) :: TextInputEventData -> TextInputEventData -> Bool

(<=) :: TextInputEventData -> TextInputEventData -> Bool

(>) :: TextInputEventData -> TextInputEventData -> Bool

(>=) :: TextInputEventData -> TextInputEventData -> Bool

max :: TextInputEventData -> TextInputEventData -> TextInputEventData

min :: TextInputEventData -> TextInputEventData -> TextInputEventData

Show TextInputEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> TextInputEventData -> ShowS show :: TextInputEventData -> String showList :: [TextInputEventData] -> ShowS
Generic TextInputEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep TextInputEventData :: Type -> Type Methods from :: TextInputEventData -> Rep TextInputEventData x to :: Rep TextInputEventData x -> TextInputEventData
type Rep TextInputEventData Source # |

Instance details

Defined in SDL.Event

type Rep TextInputEventData = D1 ('MetaData "TextInputEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "TextInputEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "textInputEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "textInputEventText") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Text)))

## Mouse events

data MouseMotionEventData Source #

A mouse or pointer device was moved.

Constructors

MouseMotionEventData |

Fields

- mouseMotionEventWindow :: !(Maybe Window)

  The `Window` with mouse focus, if any.

- mouseMotionEventWhich :: !MouseDevice

  The `MouseDevice` that was moved.

- mouseMotionEventState :: ![MouseButton]

  A collection of `MouseButton`s that are currently held down.

- mouseMotionEventPos :: !(Point V2 Int32)

  The new position of the mouse.

- mouseMotionEventRelMotion :: !(V2 Int32)

  The relative mouse motion of the mouse.

#### Instances

Instances details

Eq MouseMotionEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: MouseMotionEventData -> MouseMotionEventData -> Bool (/=) :: MouseMotionEventData -> MouseMotionEventData -> Bool
Ord MouseMotionEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: MouseMotionEventData -> MouseMotionEventData -> Ordering

(<) :: MouseMotionEventData -> MouseMotionEventData -> Bool

(<=) :: MouseMotionEventData -> MouseMotionEventData -> Bool

(>) :: MouseMotionEventData -> MouseMotionEventData -> Bool

(>=) :: MouseMotionEventData -> MouseMotionEventData -> Bool

max :: MouseMotionEventData -> MouseMotionEventData -> MouseMotionEventData

min :: MouseMotionEventData -> MouseMotionEventData -> MouseMotionEventData

Show MouseMotionEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> MouseMotionEventData -> ShowS show :: MouseMotionEventData -> String showList :: [MouseMotionEventData] -> ShowS
Generic MouseMotionEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep MouseMotionEventData :: Type -> Type Methods from :: MouseMotionEventData -> Rep MouseMotionEventData x to :: Rep MouseMotionEventData x -> MouseMotionEventData
type Rep MouseMotionEventData Source # |

Instance details

Defined in SDL.Event

type Rep MouseMotionEventData = D1 ('MetaData "MouseMotionEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "MouseMotionEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "mouseMotionEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "mouseMotionEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseDevice)) :*: (S1 ('MetaSel ('Just "mouseMotionEventState") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 [MouseButton]) :*: (S1 ('MetaSel ('Just "mouseMotionEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 Int32)) :*: S1 ('MetaSel ('Just "mouseMotionEventRelMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 Int32))))))

data MouseButtonEventData Source #

A mouse or pointer device button was pressed or released.

Constructors

MouseButtonEventData |

Fields

- mouseButtonEventWindow :: !(Maybe Window)

  The `Window` with mouse focus, if any.

- mouseButtonEventMotion :: !InputMotion

  Whether the button was pressed or released.

- mouseButtonEventWhich :: !MouseDevice

  The `MouseDevice` whose button was pressed or released.

- mouseButtonEventButton :: !MouseButton

  The button that was pressed or released.

- mouseButtonEventClicks :: !Word8

  The amount of clicks. 1 for a single-click, 2 for a double-click, etc.

- mouseButtonEventPos :: !(Point V2 Int32)

  The coordinates of the mouse click.

#### Instances

Instances details

Eq MouseButtonEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: MouseButtonEventData -> MouseButtonEventData -> Bool (/=) :: MouseButtonEventData -> MouseButtonEventData -> Bool
Ord MouseButtonEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: MouseButtonEventData -> MouseButtonEventData -> Ordering

(<) :: MouseButtonEventData -> MouseButtonEventData -> Bool

(<=) :: MouseButtonEventData -> MouseButtonEventData -> Bool

(>) :: MouseButtonEventData -> MouseButtonEventData -> Bool

(>=) :: MouseButtonEventData -> MouseButtonEventData -> Bool

max :: MouseButtonEventData -> MouseButtonEventData -> MouseButtonEventData

min :: MouseButtonEventData -> MouseButtonEventData -> MouseButtonEventData

Show MouseButtonEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> MouseButtonEventData -> ShowS show :: MouseButtonEventData -> String showList :: [MouseButtonEventData] -> ShowS
Generic MouseButtonEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep MouseButtonEventData :: Type -> Type Methods from :: MouseButtonEventData -> Rep MouseButtonEventData x to :: Rep MouseButtonEventData x -> MouseButtonEventData
type Rep MouseButtonEventData Source # |

Instance details

Defined in SDL.Event

type Rep MouseButtonEventData = D1 ('MetaData "MouseButtonEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "MouseButtonEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "mouseButtonEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: (S1 ('MetaSel ('Just "mouseButtonEventMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 InputMotion) :*: S1 ('MetaSel ('Just "mouseButtonEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseDevice))) :*: (S1 ('MetaSel ('Just "mouseButtonEventButton") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseButton) :*: (S1 ('MetaSel ('Just "mouseButtonEventClicks") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "mouseButtonEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 Int32))))))

data MouseWheelEventData Source #

Mouse wheel event information.

Constructors

MouseWheelEventData |

Fields

- mouseWheelEventWindow :: !(Maybe Window)

  The `Window` with mouse focus, if any.

- mouseWheelEventWhich :: !MouseDevice

  The `MouseDevice` whose wheel was scrolled.

- mouseWheelEventPos :: !(V2 Int32)

  The amount scrolled.

- mouseWheelEventDirection :: !MouseScrollDirection

  The scroll direction mode.

#### Instances

Instances details

Eq MouseWheelEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: MouseWheelEventData -> MouseWheelEventData -> Bool (/=) :: MouseWheelEventData -> MouseWheelEventData -> Bool
Ord MouseWheelEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: MouseWheelEventData -> MouseWheelEventData -> Ordering

(<) :: MouseWheelEventData -> MouseWheelEventData -> Bool

(<=) :: MouseWheelEventData -> MouseWheelEventData -> Bool

(>) :: MouseWheelEventData -> MouseWheelEventData -> Bool

(>=) :: MouseWheelEventData -> MouseWheelEventData -> Bool

max :: MouseWheelEventData -> MouseWheelEventData -> MouseWheelEventData

min :: MouseWheelEventData -> MouseWheelEventData -> MouseWheelEventData

Show MouseWheelEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> MouseWheelEventData -> ShowS show :: MouseWheelEventData -> String showList :: [MouseWheelEventData] -> ShowS
Generic MouseWheelEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep MouseWheelEventData :: Type -> Type Methods from :: MouseWheelEventData -> Rep MouseWheelEventData x to :: Rep MouseWheelEventData x -> MouseWheelEventData
type Rep MouseWheelEventData Source # |

Instance details

Defined in SDL.Event

type Rep MouseWheelEventData = D1 ('MetaData "MouseWheelEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "MouseWheelEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "mouseWheelEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window)) :*: S1 ('MetaSel ('Just "mouseWheelEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseDevice)) :*: (S1 ('MetaSel ('Just "mouseWheelEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 Int32)) :*: S1 ('MetaSel ('Just "mouseWheelEventDirection") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 MouseScrollDirection))))

## Joystick events

data JoyAxisEventData Source #

Joystick axis motion event information

Constructors

JoyAxisEventData |

Fields

- joyAxisEventWhich :: !JoystickID

  The instance id of the joystick that reported the event.

- joyAxisEventAxis :: !Word8

  The index of the axis that changed.

- joyAxisEventValue :: !Int16

  The current position of the axis, ranging between -32768 and 32767.

#### Instances

Instances details

Eq JoyAxisEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: JoyAxisEventData -> JoyAxisEventData -> Bool (/=) :: JoyAxisEventData -> JoyAxisEventData -> Bool
Ord JoyAxisEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: JoyAxisEventData -> JoyAxisEventData -> Ordering

(<) :: JoyAxisEventData -> JoyAxisEventData -> Bool

(<=) :: JoyAxisEventData -> JoyAxisEventData -> Bool

(>) :: JoyAxisEventData -> JoyAxisEventData -> Bool

(>=) :: JoyAxisEventData -> JoyAxisEventData -> Bool

max :: JoyAxisEventData -> JoyAxisEventData -> JoyAxisEventData

min :: JoyAxisEventData -> JoyAxisEventData -> JoyAxisEventData

Show JoyAxisEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> JoyAxisEventData -> ShowS show :: JoyAxisEventData -> String showList :: [JoyAxisEventData] -> ShowS
Generic JoyAxisEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep JoyAxisEventData :: Type -> Type Methods from :: JoyAxisEventData -> Rep JoyAxisEventData x to :: Rep JoyAxisEventData x -> JoyAxisEventData
type Rep JoyAxisEventData Source # |

Instance details

Defined in SDL.Event

type Rep JoyAxisEventData = D1 ('MetaData "JoyAxisEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "JoyAxisEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "joyAxisEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "joyAxisEventAxis") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "joyAxisEventValue") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int16))))

data JoyBallEventData Source #

Joystick trackball motion event information.

Constructors

JoyBallEventData |

Fields

- joyBallEventWhich :: !JoystickID

  The instance id of the joystick that reported the event.

- joyBallEventBall :: !Word8

  The index of the trackball that changed.

- joyBallEventRelMotion :: !(V2 Int16)

  The relative motion of the trackball.

#### Instances

Instances details

Eq JoyBallEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: JoyBallEventData -> JoyBallEventData -> Bool (/=) :: JoyBallEventData -> JoyBallEventData -> Bool
Ord JoyBallEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: JoyBallEventData -> JoyBallEventData -> Ordering

(<) :: JoyBallEventData -> JoyBallEventData -> Bool

(<=) :: JoyBallEventData -> JoyBallEventData -> Bool

(>) :: JoyBallEventData -> JoyBallEventData -> Bool

(>=) :: JoyBallEventData -> JoyBallEventData -> Bool

max :: JoyBallEventData -> JoyBallEventData -> JoyBallEventData

min :: JoyBallEventData -> JoyBallEventData -> JoyBallEventData

Show JoyBallEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> JoyBallEventData -> ShowS show :: JoyBallEventData -> String showList :: [JoyBallEventData] -> ShowS
Generic JoyBallEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep JoyBallEventData :: Type -> Type Methods from :: JoyBallEventData -> Rep JoyBallEventData x to :: Rep JoyBallEventData x -> JoyBallEventData
type Rep JoyBallEventData Source # |

Instance details

Defined in SDL.Event

type Rep JoyBallEventData = D1 ('MetaData "JoyBallEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "JoyBallEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "joyBallEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "joyBallEventBall") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "joyBallEventRelMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 Int16)))))

data JoyHatEventData Source #

Joystick hat position change event information

Constructors

JoyHatEventData |

Fields

- joyHatEventWhich :: !JoystickID

  The instance id of the joystick that reported the event.

- joyHatEventHat :: !Word8

  The index of the hat that changed.

- joyHatEventValue :: !JoyHatPosition

  The new position of the hat.

#### Instances

Instances details

Eq JoyHatEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: JoyHatEventData -> JoyHatEventData -> Bool (/=) :: JoyHatEventData -> JoyHatEventData -> Bool
Ord JoyHatEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: JoyHatEventData -> JoyHatEventData -> Ordering

(<) :: JoyHatEventData -> JoyHatEventData -> Bool

(<=) :: JoyHatEventData -> JoyHatEventData -> Bool

(>) :: JoyHatEventData -> JoyHatEventData -> Bool

(>=) :: JoyHatEventData -> JoyHatEventData -> Bool

max :: JoyHatEventData -> JoyHatEventData -> JoyHatEventData

min :: JoyHatEventData -> JoyHatEventData -> JoyHatEventData

Show JoyHatEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> JoyHatEventData -> ShowS show :: JoyHatEventData -> String showList :: [JoyHatEventData] -> ShowS
Generic JoyHatEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep JoyHatEventData :: Type -> Type Methods from :: JoyHatEventData -> Rep JoyHatEventData x to :: Rep JoyHatEventData x -> JoyHatEventData
type Rep JoyHatEventData Source # |

Instance details

Defined in SDL.Event

type Rep JoyHatEventData = D1 ('MetaData "JoyHatEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "JoyHatEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "joyHatEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "joyHatEventHat") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "joyHatEventValue") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyHatPosition))))

data JoyButtonEventData Source #

Joystick button event information.

Constructors

JoyButtonEventData |

Fields

- joyButtonEventWhich :: !JoystickID

  The instance id of the joystick that reported the event.

- joyButtonEventButton :: !Word8

  The index of the button that changed.

- joyButtonEventState :: !JoyButtonState

  The state of the button.

#### Instances

Instances details

Eq JoyButtonEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: JoyButtonEventData -> JoyButtonEventData -> Bool (/=) :: JoyButtonEventData -> JoyButtonEventData -> Bool
Ord JoyButtonEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: JoyButtonEventData -> JoyButtonEventData -> Ordering

(<) :: JoyButtonEventData -> JoyButtonEventData -> Bool

(<=) :: JoyButtonEventData -> JoyButtonEventData -> Bool

(>) :: JoyButtonEventData -> JoyButtonEventData -> Bool

(>=) :: JoyButtonEventData -> JoyButtonEventData -> Bool

max :: JoyButtonEventData -> JoyButtonEventData -> JoyButtonEventData

min :: JoyButtonEventData -> JoyButtonEventData -> JoyButtonEventData

Show JoyButtonEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> JoyButtonEventData -> ShowS show :: JoyButtonEventData -> String showList :: [JoyButtonEventData] -> ShowS
Generic JoyButtonEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep JoyButtonEventData :: Type -> Type Methods from :: JoyButtonEventData -> Rep JoyButtonEventData x to :: Rep JoyButtonEventData x -> JoyButtonEventData
type Rep JoyButtonEventData Source # |

Instance details

Defined in SDL.Event

type Rep JoyButtonEventData = D1 ('MetaData "JoyButtonEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "JoyButtonEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "joyButtonEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "joyButtonEventButton") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "joyButtonEventState") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyButtonState))))

data JoyDeviceEventData Source #

Joystick device event information.

Constructors

JoyDeviceEventData |

Fields

- joyDeviceEventConnection :: !JoyDeviceConnection

  Was the device added or removed?

- joyDeviceEventWhich :: !Int32

  The instance id of the joystick that reported the event.

#### Instances

Instances details

Eq JoyDeviceEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool (/=) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool
Ord JoyDeviceEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: JoyDeviceEventData -> JoyDeviceEventData -> Ordering

(<) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool

(<=) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool

(>) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool

(>=) :: JoyDeviceEventData -> JoyDeviceEventData -> Bool

max :: JoyDeviceEventData -> JoyDeviceEventData -> JoyDeviceEventData

min :: JoyDeviceEventData -> JoyDeviceEventData -> JoyDeviceEventData

Show JoyDeviceEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> JoyDeviceEventData -> ShowS show :: JoyDeviceEventData -> String showList :: [JoyDeviceEventData] -> ShowS
Generic JoyDeviceEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep JoyDeviceEventData :: Type -> Type Methods from :: JoyDeviceEventData -> Rep JoyDeviceEventData x to :: Rep JoyDeviceEventData x -> JoyDeviceEventData
type Rep JoyDeviceEventData Source # |

Instance details

Defined in SDL.Event

type Rep JoyDeviceEventData = D1 ('MetaData "JoyDeviceEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "JoyDeviceEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "joyDeviceEventConnection") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoyDeviceConnection) :*: S1 ('MetaSel ('Just "joyDeviceEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int32)))

## Controller events

data ControllerAxisEventData Source #

Game controller axis motion event information.

Constructors

ControllerAxisEventData |

Fields

- controllerAxisEventWhich :: !JoystickID

  The joystick instance ID that reported the event.

- controllerAxisEventAxis :: !Word8

  The index of the axis.

- controllerAxisEventValue :: !Int16

  The axis value ranging between -32768 and 32767.

#### Instances

Instances details

Eq ControllerAxisEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool (/=) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool
Ord ControllerAxisEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: ControllerAxisEventData -> ControllerAxisEventData -> Ordering

(<) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool

(<=) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool

(>) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool

(>=) :: ControllerAxisEventData -> ControllerAxisEventData -> Bool

max :: ControllerAxisEventData -> ControllerAxisEventData -> ControllerAxisEventData

min :: ControllerAxisEventData -> ControllerAxisEventData -> ControllerAxisEventData

Show ControllerAxisEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> ControllerAxisEventData -> ShowS show :: ControllerAxisEventData -> String showList :: [ControllerAxisEventData] -> ShowS
Generic ControllerAxisEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep ControllerAxisEventData :: Type -> Type Methods from :: ControllerAxisEventData -> Rep ControllerAxisEventData x to :: Rep ControllerAxisEventData x -> ControllerAxisEventData
type Rep ControllerAxisEventData Source # |

Instance details

Defined in SDL.Event

type Rep ControllerAxisEventData = D1 ('MetaData "ControllerAxisEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "ControllerAxisEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "controllerAxisEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "controllerAxisEventAxis") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word8) :*: S1 ('MetaSel ('Just "controllerAxisEventValue") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int16))))

data ControllerButtonEventData Source #

Game controller button event information

Constructors

ControllerButtonEventData |

Fields

- controllerButtonEventWhich :: !JoystickID

  The joystick instance ID that reported the event.

- controllerButtonEventButton :: !ControllerButton

  The controller button.

- controllerButtonEventState :: !ControllerButtonState

  The state of the button.

#### Instances

Instances details

Eq ControllerButtonEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool (/=) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool
Ord ControllerButtonEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: ControllerButtonEventData -> ControllerButtonEventData -> Ordering

(<) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool

(<=) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool

(>) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool

(>=) :: ControllerButtonEventData -> ControllerButtonEventData -> Bool

max :: ControllerButtonEventData -> ControllerButtonEventData -> ControllerButtonEventData

min :: ControllerButtonEventData -> ControllerButtonEventData -> ControllerButtonEventData

Show ControllerButtonEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> ControllerButtonEventData -> ShowS show :: ControllerButtonEventData -> String showList :: [ControllerButtonEventData] -> ShowS
Generic ControllerButtonEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep ControllerButtonEventData :: Type -> Type Methods from :: ControllerButtonEventData -> Rep ControllerButtonEventData x to :: Rep ControllerButtonEventData x -> ControllerButtonEventData
type Rep ControllerButtonEventData Source # |

Instance details

Defined in SDL.Event

type Rep ControllerButtonEventData = D1 ('MetaData "ControllerButtonEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "ControllerButtonEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "controllerButtonEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 JoystickID) :*: (S1 ('MetaSel ('Just "controllerButtonEventButton") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerButton) :*: S1 ('MetaSel ('Just "controllerButtonEventState") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerButtonState))))

data ControllerDeviceEventData Source #

Controller device event information

Constructors

ControllerDeviceEventData |

Fields

- controllerDeviceEventConnection :: !ControllerDeviceConnection

  Was the device added, removed, or remapped?

- controllerDeviceEventWhich :: !Int32

  The joystick instance ID that reported the event.

#### Instances

Instances details

Eq ControllerDeviceEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool (/=) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool
Ord ControllerDeviceEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: ControllerDeviceEventData -> ControllerDeviceEventData -> Ordering

(<) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool

(<=) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool

(>) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool

(>=) :: ControllerDeviceEventData -> ControllerDeviceEventData -> Bool

max :: ControllerDeviceEventData -> ControllerDeviceEventData -> ControllerDeviceEventData

min :: ControllerDeviceEventData -> ControllerDeviceEventData -> ControllerDeviceEventData

Show ControllerDeviceEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> ControllerDeviceEventData -> ShowS show :: ControllerDeviceEventData -> String showList :: [ControllerDeviceEventData] -> ShowS
Generic ControllerDeviceEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep ControllerDeviceEventData :: Type -> Type Methods from :: ControllerDeviceEventData -> Rep ControllerDeviceEventData x to :: Rep ControllerDeviceEventData x -> ControllerDeviceEventData
type Rep ControllerDeviceEventData Source # |

Instance details

Defined in SDL.Event

type Rep ControllerDeviceEventData = D1 ('MetaData "ControllerDeviceEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "ControllerDeviceEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "controllerDeviceEventConnection") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 ControllerDeviceConnection) :*: S1 ('MetaSel ('Just "controllerDeviceEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int32)))

## Audio events

data AudioDeviceEventData Source #

Constructors

AudioDeviceEventData |

Fields

- audioDeviceEventIsAddition :: !Bool

  If the audio device is an addition, or a removal.

- audioDeviceEventWhich :: !Word32

  The audio device ID that reported the event.

- audioDeviceEventIsCapture :: !Bool

  If the audio device is a capture device.

#### Instances

Instances details

Eq AudioDeviceEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool (/=) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool
Ord AudioDeviceEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: AudioDeviceEventData -> AudioDeviceEventData -> Ordering

(<) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool

(<=) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool

(>) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool

(>=) :: AudioDeviceEventData -> AudioDeviceEventData -> Bool

max :: AudioDeviceEventData -> AudioDeviceEventData -> AudioDeviceEventData

min :: AudioDeviceEventData -> AudioDeviceEventData -> AudioDeviceEventData

Show AudioDeviceEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> AudioDeviceEventData -> ShowS show :: AudioDeviceEventData -> String showList :: [AudioDeviceEventData] -> ShowS
Generic AudioDeviceEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep AudioDeviceEventData :: Type -> Type Methods from :: AudioDeviceEventData -> Rep AudioDeviceEventData x to :: Rep AudioDeviceEventData x -> AudioDeviceEventData
type Rep AudioDeviceEventData Source # |

Instance details

Defined in SDL.Event

type Rep AudioDeviceEventData = D1 ('MetaData "AudioDeviceEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "AudioDeviceEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "audioDeviceEventIsAddition") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool) :*: (S1 ('MetaSel ('Just "audioDeviceEventWhich") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word32) :*: S1 ('MetaSel ('Just "audioDeviceEventIsCapture") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Bool))))

## User events

data UserEventData Source #

Event data for application-defined events.

Constructors

UserEventData |

Fields

- userEventType :: !Word32

  User defined event type.

- userEventWindow :: !(Maybe Window)

  The associated `Window`.

- userEventCode :: !Int32

  User defined event code.

- userEventData1 :: !(Ptr ())

  User defined data pointer.

- userEventData2 :: !(Ptr ())

  User defined data pointer.

#### Instances

Instances details

Eq UserEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: UserEventData -> UserEventData -> Bool (/=) :: UserEventData -> UserEventData -> Bool
Ord UserEventData Source # |
Instance details Defined in SDL.Event Methods compare :: UserEventData -> UserEventData -> Ordering (<) :: UserEventData -> UserEventData -> Bool (<=) :: UserEventData -> UserEventData -> Bool (>) :: UserEventData -> UserEventData -> Bool (>=) :: UserEventData -> UserEventData -> Bool max :: UserEventData -> UserEventData -> UserEventData min :: UserEventData -> UserEventData -> UserEventData
Show UserEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> UserEventData -> ShowS show :: UserEventData -> String showList :: [UserEventData] -> ShowS
Generic UserEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep UserEventData :: Type -> Type Methods from :: UserEventData -> Rep UserEventData x to :: Rep UserEventData x -> UserEventData
type Rep UserEventData Source # |

Instance details

Defined in SDL.Event

type Rep UserEventData = D1 ('MetaData "UserEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "UserEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "userEventType") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word32) :*: S1 ('MetaSel ('Just "userEventWindow") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Maybe Window))) :*: (S1 ('MetaSel ('Just "userEventCode") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int32) :*: (S1 ('MetaSel ('Just "userEventData1") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Ptr ())) :*: S1 ('MetaSel ('Just "userEventData2") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Ptr ()))))))

## Touch events

data TouchFingerEventData Source #

Finger touch event information.

Constructors

TouchFingerEventData |

Fields

- touchFingerEventTouchID :: !TouchID

  The touch device index.

- touchFingerEventFingerID :: !FingerID

  The finger index.

- touchFingerEventMotion :: !InputMotion

  Whether the finger was pressed or released.

- touchFingerEventPos :: !(Point V2 CFloat)

  The location of the touch event, normalized between 0 and 1.

- touchFingerEventPressure :: !CFloat

  The quantity of the pressure applied, normalized between 0 and 1.

#### Instances

Instances details

Eq TouchFingerEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: TouchFingerEventData -> TouchFingerEventData -> Bool (/=) :: TouchFingerEventData -> TouchFingerEventData -> Bool
Ord TouchFingerEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: TouchFingerEventData -> TouchFingerEventData -> Ordering

(<) :: TouchFingerEventData -> TouchFingerEventData -> Bool

(<=) :: TouchFingerEventData -> TouchFingerEventData -> Bool

(>) :: TouchFingerEventData -> TouchFingerEventData -> Bool

(>=) :: TouchFingerEventData -> TouchFingerEventData -> Bool

max :: TouchFingerEventData -> TouchFingerEventData -> TouchFingerEventData

min :: TouchFingerEventData -> TouchFingerEventData -> TouchFingerEventData

Show TouchFingerEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> TouchFingerEventData -> ShowS show :: TouchFingerEventData -> String showList :: [TouchFingerEventData] -> ShowS
Generic TouchFingerEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep TouchFingerEventData :: Type -> Type Methods from :: TouchFingerEventData -> Rep TouchFingerEventData x to :: Rep TouchFingerEventData x -> TouchFingerEventData
type Rep TouchFingerEventData Source # |

Instance details

Defined in SDL.Event

type Rep TouchFingerEventData = D1 ('MetaData "TouchFingerEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "TouchFingerEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "touchFingerEventTouchID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchID) :*: S1 ('MetaSel ('Just "touchFingerEventFingerID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 FingerID)) :*: (S1 ('MetaSel ('Just "touchFingerEventMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 InputMotion) :*: (S1 ('MetaSel ('Just "touchFingerEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 CFloat)) :*: S1 ('MetaSel ('Just "touchFingerEventPressure") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 CFloat)))))

data TouchFingerMotionEventData Source #

Finger motion event information.

Constructors

TouchFingerMotionEventData |

Fields

- touchFingerMotionEventTouchID :: !TouchID

  The touch device index.

- touchFingerMotionEventFingerID :: !FingerID

  The finger index.

- touchFingerMotionEventPos :: !(Point V2 CFloat)

  The location of the touch event, normalized between 0 and 1.

- touchFingerMotionEventRelMotion :: !(V2 CFloat)

  The distance moved, normalized between -1 and 1.

- touchFingerMotionEventPressure :: !CFloat

  The quantity of the pressure applied, normalized between 0 and 1.

#### Instances

Instances details

Eq TouchFingerMotionEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool (/=) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool
Ord TouchFingerMotionEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Ordering

(<) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool

(<=) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool

(>) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool

(>=) :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> Bool

max :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> TouchFingerMotionEventData

min :: TouchFingerMotionEventData -> TouchFingerMotionEventData -> TouchFingerMotionEventData

Show TouchFingerMotionEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> TouchFingerMotionEventData -> ShowS show :: TouchFingerMotionEventData -> String showList :: [TouchFingerMotionEventData] -> ShowS
Generic TouchFingerMotionEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep TouchFingerMotionEventData :: Type -> Type Methods from :: TouchFingerMotionEventData -> Rep TouchFingerMotionEventData x to :: Rep TouchFingerMotionEventData x -> TouchFingerMotionEventData
type Rep TouchFingerMotionEventData Source # |

Instance details

Defined in SDL.Event

type Rep TouchFingerMotionEventData = D1 ('MetaData "TouchFingerMotionEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "TouchFingerMotionEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "touchFingerMotionEventTouchID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchID) :*: S1 ('MetaSel ('Just "touchFingerMotionEventFingerID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 FingerID)) :*: (S1 ('MetaSel ('Just "touchFingerMotionEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 CFloat)) :*: (S1 ('MetaSel ('Just "touchFingerMotionEventRelMotion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (V2 CFloat)) :*: S1 ('MetaSel ('Just "touchFingerMotionEventPressure") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 CFloat)))))

## Gesture events

data MultiGestureEventData Source #

Multiple finger gesture event information

Constructors

MultiGestureEventData |

Fields

- multiGestureEventTouchID :: !TouchID

  The touch device index.

- multiGestureEventDTheta :: !CFloat

  The amount that the fingers rotated during this motion.

- multiGestureEventDDist :: !CFloat

  The amount that the fingers pinched during this motion.

- multiGestureEventPos :: !(Point V2 CFloat)

  The normalized center of the gesture.

- multiGestureEventNumFingers :: !Word16

  The number of fingers used in this gesture.

#### Instances

Instances details

Eq MultiGestureEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: MultiGestureEventData -> MultiGestureEventData -> Bool (/=) :: MultiGestureEventData -> MultiGestureEventData -> Bool
Ord MultiGestureEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: MultiGestureEventData -> MultiGestureEventData -> Ordering

(<) :: MultiGestureEventData -> MultiGestureEventData -> Bool

(<=) :: MultiGestureEventData -> MultiGestureEventData -> Bool

(>) :: MultiGestureEventData -> MultiGestureEventData -> Bool

(>=) :: MultiGestureEventData -> MultiGestureEventData -> Bool

max :: MultiGestureEventData -> MultiGestureEventData -> MultiGestureEventData

min :: MultiGestureEventData -> MultiGestureEventData -> MultiGestureEventData

Show MultiGestureEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> MultiGestureEventData -> ShowS show :: MultiGestureEventData -> String showList :: [MultiGestureEventData] -> ShowS
Generic MultiGestureEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep MultiGestureEventData :: Type -> Type Methods from :: MultiGestureEventData -> Rep MultiGestureEventData x to :: Rep MultiGestureEventData x -> MultiGestureEventData
type Rep MultiGestureEventData Source # |

Instance details

Defined in SDL.Event

type Rep MultiGestureEventData = D1 ('MetaData "MultiGestureEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "MultiGestureEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "multiGestureEventTouchID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchID) :*: S1 ('MetaSel ('Just "multiGestureEventDTheta") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 CFloat)) :*: (S1 ('MetaSel ('Just "multiGestureEventDDist") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 CFloat) :*: (S1 ('MetaSel ('Just "multiGestureEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 CFloat)) :*: S1 ('MetaSel ('Just "multiGestureEventNumFingers") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word16)))))

data DollarGestureEventData Source #

Complex gesture event information.

Constructors

DollarGestureEventData |

Fields

- dollarGestureEventTouchID :: !TouchID

  The touch device index.

- dollarGestureEventGestureID :: !GestureID

  The unique id of the closest gesture to the performed stroke.

- dollarGestureEventNumFingers :: !Word32

  The number of fingers used to draw the stroke.

- dollarGestureEventError :: !CFloat

  The difference between the gesture template and the actual performed gesture (lower errors correspond to closer matches).

- dollarGestureEventPos :: !(Point V2 CFloat)

  The normalized center of the gesture.

#### Instances

Instances details

Eq DollarGestureEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: DollarGestureEventData -> DollarGestureEventData -> Bool (/=) :: DollarGestureEventData -> DollarGestureEventData -> Bool
Ord DollarGestureEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: DollarGestureEventData -> DollarGestureEventData -> Ordering

(<) :: DollarGestureEventData -> DollarGestureEventData -> Bool

(<=) :: DollarGestureEventData -> DollarGestureEventData -> Bool

(>) :: DollarGestureEventData -> DollarGestureEventData -> Bool

(>=) :: DollarGestureEventData -> DollarGestureEventData -> Bool

max :: DollarGestureEventData -> DollarGestureEventData -> DollarGestureEventData

min :: DollarGestureEventData -> DollarGestureEventData -> DollarGestureEventData

Show DollarGestureEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> DollarGestureEventData -> ShowS show :: DollarGestureEventData -> String showList :: [DollarGestureEventData] -> ShowS
Generic DollarGestureEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep DollarGestureEventData :: Type -> Type Methods from :: DollarGestureEventData -> Rep DollarGestureEventData x to :: Rep DollarGestureEventData x -> DollarGestureEventData
type Rep DollarGestureEventData Source # |

Instance details

Defined in SDL.Event

type Rep DollarGestureEventData = D1 ('MetaData "DollarGestureEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "DollarGestureEventData" 'PrefixI 'True) ((S1 ('MetaSel ('Just "dollarGestureEventTouchID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 TouchID) :*: S1 ('MetaSel ('Just "dollarGestureEventGestureID") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 GestureID)) :*: (S1 ('MetaSel ('Just "dollarGestureEventNumFingers") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Word32) :*: (S1 ('MetaSel ('Just "dollarGestureEventError") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 CFloat) :*: S1 ('MetaSel ('Just "dollarGestureEventPos") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 (Point V2 CFloat))))))

## Drag and drop events

newtype DropEventData Source #

An event used to request a file open by the system

Constructors

DropEventData |

Fields

- dropEventFile :: CString

  The file name.

#### Instances

Instances details

Eq DropEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: DropEventData -> DropEventData -> Bool (/=) :: DropEventData -> DropEventData -> Bool
Ord DropEventData Source # |
Instance details Defined in SDL.Event Methods compare :: DropEventData -> DropEventData -> Ordering (<) :: DropEventData -> DropEventData -> Bool (<=) :: DropEventData -> DropEventData -> Bool (>) :: DropEventData -> DropEventData -> Bool (>=) :: DropEventData -> DropEventData -> Bool max :: DropEventData -> DropEventData -> DropEventData min :: DropEventData -> DropEventData -> DropEventData
Show DropEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> DropEventData -> ShowS show :: DropEventData -> String showList :: [DropEventData] -> ShowS
Generic DropEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep DropEventData :: Type -> Type Methods from :: DropEventData -> Rep DropEventData x to :: Rep DropEventData x -> DropEventData
type Rep DropEventData Source # |
Instance details Defined in SDL.Event type Rep DropEventData = D1 ('MetaData "DropEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "DropEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "dropEventFile") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 CString)))

## Unknown events

newtype UnknownEventData Source #

SDL reported an unknown event type.

Constructors

UnknownEventData |

Fields

- unknownEventType :: Word32

  The unknown event code.

#### Instances

Instances details

Eq UnknownEventData Source # |
Instance details Defined in SDL.Event Methods (==) :: UnknownEventData -> UnknownEventData -> Bool (/=) :: UnknownEventData -> UnknownEventData -> Bool
Ord UnknownEventData Source # |

Instance details

Defined in SDL.Event

Methods

compare :: UnknownEventData -> UnknownEventData -> Ordering

(<) :: UnknownEventData -> UnknownEventData -> Bool

(<=) :: UnknownEventData -> UnknownEventData -> Bool

(>) :: UnknownEventData -> UnknownEventData -> Bool

(>=) :: UnknownEventData -> UnknownEventData -> Bool

max :: UnknownEventData -> UnknownEventData -> UnknownEventData

min :: UnknownEventData -> UnknownEventData -> UnknownEventData

Show UnknownEventData Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> UnknownEventData -> ShowS show :: UnknownEventData -> String showList :: [UnknownEventData] -> ShowS
Generic UnknownEventData Source # |
Instance details Defined in SDL.Event Associated Types type Rep UnknownEventData :: Type -> Type Methods from :: UnknownEventData -> Rep UnknownEventData x to :: Rep UnknownEventData x -> UnknownEventData
type Rep UnknownEventData Source # |
Instance details Defined in SDL.Event type Rep UnknownEventData = D1 ('MetaData "UnknownEventData" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'True) (C1 ('MetaCons "UnknownEventData" 'PrefixI 'True) (S1 ('MetaSel ('Just "unknownEventType") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Word32)))

# Auxiliary event data

data InputMotion Source #

Constructors

Released |
Pressed |

#### Instances

Instances details

Bounded InputMotion Source # |
Instance details Defined in SDL.Event Methods minBound :: InputMotion maxBound :: InputMotion
Enum InputMotion Source # |

Instance details

Defined in SDL.Event

Methods

succ :: InputMotion -> InputMotion

pred :: InputMotion -> InputMotion

toEnum :: Int -> InputMotion

fromEnum :: InputMotion -> Int

enumFrom :: InputMotion -> [InputMotion]

enumFromThen :: InputMotion -> InputMotion -> [InputMotion]

enumFromTo :: InputMotion -> InputMotion -> [InputMotion]

enumFromThenTo :: InputMotion -> InputMotion -> InputMotion -> [InputMotion]

Eq InputMotion Source # |
Instance details Defined in SDL.Event Methods (==) :: InputMotion -> InputMotion -> Bool (/=) :: InputMotion -> InputMotion -> Bool
Data InputMotion Source # |

Instance details

Defined in SDL.Event

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> InputMotion -> c InputMotion

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c InputMotion

toConstr :: InputMotion -> Constr

dataTypeOf :: InputMotion -> DataType

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c InputMotion)

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c InputMotion)

gmapT :: (forall b. Data b => b -> b) -> InputMotion -> InputMotion

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> InputMotion -> r

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> InputMotion -> r

gmapQ :: (forall d. Data d => d -> u) -> InputMotion -> [u]

gmapQi :: Int -> (forall d. Data d => d -> u) -> InputMotion -> u

gmapM :: Monad m => (forall d. Data d => d -> m d) -> InputMotion -> m InputMotion

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> InputMotion -> m InputMotion

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> InputMotion -> m InputMotion

Ord InputMotion Source # |
Instance details Defined in SDL.Event Methods compare :: InputMotion -> InputMotion -> Ordering (<) :: InputMotion -> InputMotion -> Bool (<=) :: InputMotion -> InputMotion -> Bool (>) :: InputMotion -> InputMotion -> Bool (>=) :: InputMotion -> InputMotion -> Bool max :: InputMotion -> InputMotion -> InputMotion min :: InputMotion -> InputMotion -> InputMotion
Read InputMotion Source # |
Instance details Defined in SDL.Event Methods readsPrec :: Int -> ReadS InputMotion readList :: ReadS [InputMotion] readPrec :: ReadPrec InputMotion readListPrec :: ReadPrec [InputMotion]
Show InputMotion Source # |
Instance details Defined in SDL.Event Methods showsPrec :: Int -> InputMotion -> ShowS show :: InputMotion -> String showList :: [InputMotion] -> ShowS
Generic InputMotion Source # |
Instance details Defined in SDL.Event Associated Types type Rep InputMotion :: Type -> Type Methods from :: InputMotion -> Rep InputMotion x to :: Rep InputMotion x -> InputMotion
type Rep InputMotion Source # |
Instance details Defined in SDL.Event type Rep InputMotion = D1 ('MetaData "InputMotion" "SDL.Event" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) (C1 ('MetaCons "Released" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "Pressed" 'PrefixI 'False) (U1 :: Type -> Type))

data MouseButton Source #

Constructors

ButtonLeft |
ButtonMiddle |
ButtonRight |
ButtonX1 |
ButtonX2 |
ButtonExtra !Int | An unknown mouse button.

#### Instances

Instances details

Eq MouseButton Source # |
Instance details Defined in SDL.Input.Mouse Methods (==) :: MouseButton -> MouseButton -> Bool (/=) :: MouseButton -> MouseButton -> Bool
Data MouseButton Source # |

Instance details

Defined in SDL.Input.Mouse

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> MouseButton -> c MouseButton

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c MouseButton

toConstr :: MouseButton -> Constr

dataTypeOf :: MouseButton -> DataType

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c MouseButton)

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c MouseButton)

gmapT :: (forall b. Data b => b -> b) -> MouseButton -> MouseButton

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> MouseButton -> r

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> MouseButton -> r

gmapQ :: (forall d. Data d => d -> u) -> MouseButton -> [u]

gmapQi :: Int -> (forall d. Data d => d -> u) -> MouseButton -> u

gmapM :: Monad m => (forall d. Data d => d -> m d) -> MouseButton -> m MouseButton

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> MouseButton -> m MouseButton

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> MouseButton -> m MouseButton

Ord MouseButton Source # |
Instance details Defined in SDL.Input.Mouse Methods compare :: MouseButton -> MouseButton -> Ordering (<) :: MouseButton -> MouseButton -> Bool (<=) :: MouseButton -> MouseButton -> Bool (>) :: MouseButton -> MouseButton -> Bool (>=) :: MouseButton -> MouseButton -> Bool max :: MouseButton -> MouseButton -> MouseButton min :: MouseButton -> MouseButton -> MouseButton
Read MouseButton Source # |
Instance details Defined in SDL.Input.Mouse Methods readsPrec :: Int -> ReadS MouseButton readList :: ReadS [MouseButton] readPrec :: ReadPrec MouseButton readListPrec :: ReadPrec [MouseButton]
Show MouseButton Source # |
Instance details Defined in SDL.Input.Mouse Methods showsPrec :: Int -> MouseButton -> ShowS show :: MouseButton -> String showList :: [MouseButton] -> ShowS
Generic MouseButton Source # |
Instance details Defined in SDL.Input.Mouse Associated Types type Rep MouseButton :: Type -> Type Methods from :: MouseButton -> Rep MouseButton x to :: Rep MouseButton x -> MouseButton
ToNumber MouseButton Word8 Source # |
Instance details Defined in SDL.Input.Mouse Methods toNumber :: MouseButton -> Word8 Source #
FromNumber MouseButton Word8 Source # |
Instance details Defined in SDL.Input.Mouse Methods fromNumber :: Word8 -> MouseButton Source #
type Rep MouseButton Source # |

Instance details

Defined in SDL.Input.Mouse

type Rep MouseButton = D1 ('MetaData "MouseButton" "SDL.Input.Mouse" "sdl2-2.5.2.0-Cx4Ipj2keSJFpflqvJYEGr" 'False) ((C1 ('MetaCons "ButtonLeft" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "ButtonMiddle" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "ButtonRight" 'PrefixI 'False) (U1 :: Type -> Type))) :+: (C1 ('MetaCons "ButtonX1" 'PrefixI 'False) (U1 :: Type -> Type) :+: (C1 ('MetaCons "ButtonX2" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "ButtonExtra" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Int)))))